window.onload = () => {

   // Copy of Ext.state.Provider.encodeValue() to encode the information
   // in the syntax needed for the ExtJS state manager.
   // Ext.isData and Eyt.isArray where replaced by there implementation code
   const encodeValue = function(value) {
      let flat = "",
          i = 0,
          enc, len, key;

      if (value === null) {
         return "e:1";
      } else if (typeof value === "number") {
         enc = `n:${  value}`;
      } else if (typeof value === "boolean") {
         enc = `b:${  value ? "1" : "0"}`;
      } else if (toString.call(value) === "[object Date]") {
         enc = `d:${  value.toUTCString()}`;
      } else if (toString.call(value) === "[object Array]") {
         for (len = value.length; i < len; i++) {
            flat += this.encodeValue(value[i]);

            if (i !== len - 1) {
               flat += "^";
            }
         }

         enc = `a:${  flat}`;
      } else if (typeof value === "object") {
         for (key in value) {
            if (typeof value[key] !== "function" && value[key] !== undefined) {
               flat += `${key  }=${  encodeValue(value[key])  }^`;
            }
         }

         enc = `o:${  flat.substring(0, flat.length - 1)}`;
      } else {
         enc = `s:${  value}`;
      }

      return escape(enc);
   };

   // store for reuse after login redirect
   localStorage.setItem("ext-POST_LOGIN_URL", encodeValue(
      {
         search : window.location.search,
         hash   : window.location.hash
      })
   );
   window.location.href = document.body.dataset.redirectUrl;
};